version: '2'

services:
  mysql-master:
    image: {{ mysql_image }}
    ports:
      - '3306:3306'
    restart: unless-stopped
    volumes:
       - '~/mysql/db/master:/var/lib/mysql'
    environment:
      - MYSQL_REPLICATION_MODE=master
      - MYSQL_REPLICATION_USER={{ mysql_replication_user }}
      - MYSQL_REPLICATION_PASSWORD={{ mysql_replication_password }}
      - MYSQL_ROOT_PASSWORD={{ mysql_root_password }}
      - MYSQL_USER={{ mysql_user }}
      - MYSQL_PASSWORD={{ mysql_password }}
      - MYSQL_DATABASE={{ mysql_database }}

  mysql-slave:
    image: {{ mysql_image }}
    restart: unless-stopped
    ports:
      - '3307:3306'
    volumes:
      - '~/mysql/db/slave:/var/lib/mysql'
    depends_on:
      - mysql-master
    environment:
      - MYSQL_ROOT_PASSWORD={{ mysql_root_password }}
      - MYSQL_REPLICATION_MODE=slave
      - MYSQL_REPLICATION_USER={{ mysql_replication_user }}
      - MYSQL_REPLICATION_PASSWORD={{ mysql_replication_password }}
      - MYSQL_MASTER_HOST=mysql-master
      - MYSQL_MASTER_PORT_NUMBER=3306
      - MYSQL_MASTER_ROOT_PASSWORD={{ mysql_root_password }}


  mysql_master-exporter:
    image: prom/mysqld-exporter:latest
    container_name: mysql_master-exporter
    restart: unless-stopped
    command:
      - --mysqld.username=root:{{ mysql_root_password }}
      - --mysqld.address=mysql-master:3306
      - --collect.info_schema.tablestats
    ports:
      - '9104:9104'
    links:
      - mysql-master
    depends_on:
      - mysql-master

  mysql_slave-exporter:
    image: prom/mysqld-exporter:latest
    container_name: mysql_slave-exporter
    restart: unless-stopped
    command:
      - --mysqld.address=mysql-slave:3306
      - --collect.info_schema.tablestats
      - --mysqld.username=root:{{ mysql_root_password }}    
    ports:
      - '9105:9104'
    links:
      - mysql-slave
    depends_on:
      - mysql-slave

volumes:
  mysql_master1_data:
    driver: local
  mysql_slave1_data:
    driver: local
networks:
  default:
    driver: bridge
